#include <Inventor/Win/SoWin.h>
#include <Inventor/nodes/SoSeparator.h>

#include <Inventor/Win/SoWinRenderArea.h>
#include <Inventor/Win/viewers/SoWinExaminerViewer.h>

#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoMaterialBinding.h>
#include <Inventor/SbColor.h>

#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoOrthographicCamera.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>

#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/nodes/SoCoordinate3.h>

#include <Inventor/nodes/SoCube.h>

//aca crearemos los cubos o cuadrados cada uno en SoSeparator
SoSeparator* creaCubos(){
	//este separador contendra todos los cubos
	SoSeparator *result= new SoSeparator;
	result->ref();

	// Create a light
	result->addChild(new SoDirectionalLight);
	
	//creamos y definimos el cubo
	SoCube  *cubo = new SoCube;	
	result->addChild(cubo);
	
	//---------------------------


	//no elimines este separador y regresalo
	result->unrefNoDelete();
	return result;
}
int main(){

	// Initialize Inventor and Windows
	HWND myWindow  = SoWin::init("aloha","view" );
	if (myWindow == NULL) 
	exit(1);
	
	SoSeparator *root = creaCubos();
	root->ref();
	
	SoOrthographicCamera *orthoViewAll = new SoOrthographicCamera;
	
	SoWinRenderArea *myRenderArea = new SoWinRenderArea(myWindow);
	myRenderArea->setBackgroundColor(SbColor(1.0f, 0.0f, 1.0f));

	SbViewportRegion myRegion(myRenderArea->getSize());
	orthoViewAll->viewAll(root, myRegion);
	root->addChild(orthoViewAll );
	myRenderArea->setSceneGraph(root);
	myRenderArea->setTitle("Cameras");
	myRenderArea->show();

	SoWin::show(myWindow);
	SoWin::mainLoop();

}