#include <Inventor/SbLinear.h>
#include <Inventor/SoDB.h>
#include <Inventor/SoInput.h>
#include <Inventor/Win/SoWin.h>
#include <Inventor/Win/SoWinRenderArea.h>
#include <Inventor/nodes/SoBlinker.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoOrthographicCamera.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoCube.h>

SoSeparator* creaCubos(){
	//este separador contendra todos los cubos
	SoSeparator *result= new SoSeparator;
	result->ref();

	//creamos y definimos el cubo
	SoCube  *cubo = new SoCube;	
	result->addChild(cubo);
	
	//---------------------------


	//no elimines este separador y regresalo
	result->unrefNoDelete();
	return result;
}
int main(int, char **argv)
{
   
	// Initialize Inventor and Windows
	HWND myWindow  = SoWin::init("aloha","view" );
	if (myWindow == NULL) 
		exit(1);
	
   SoSeparator *root = new SoSeparator;
   root->ref();
	
   SoOrthographicCamera *orthoViewAll = new SoOrthographicCamera;
   root->addChild(orthoViewAll );
   // Create a light
   root->addChild(new SoDirectionalLight);

   
   root->addChild(new SoCube);
	
   SoWinRenderArea *myRenderArea = new SoWinRenderArea(myWindow);


   // Establish camera positions. 
   // First do a viewAll() on all three cameras.  
   // Then modify the position of the off-center camera.
   SbViewportRegion myRegion(myRenderArea->getSize());
   orthoViewAll->viewAll(root, myRegion);
   
   myRenderArea->setSceneGraph(root);
   myRenderArea->setTitle("Cameras");
   myRenderArea->show();

   
	SoWin::show(myWindow);
	SoWin::mainLoop();
}